from collections import deque, defaultdict

def find_guarded_warehouses(n, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    def bfs(start, endurance):
        visited = set()
        queue = deque([(start, 0)])
        visited.add(start)

        while queue:
            node, dist = queue.popleft()

            if dist <= endurance:
                guarded.add(node)

                for neighbor in graph[node]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, dist + 1))

    for pi, hi in guards:
        bfs(pi, hi)

    return sorted(list(guarded))

n, m, k = map(int, input().strip().split())
roads = [tuple(map(int, input().strip().split())) for _ in range(m)]
guards = [tuple(map(int, input().strip().split())) for _ in range(k)]

guarded_warehouses = find_guarded_warehouses(n, roads, guards)

print(len(guarded_warehouses))
print(' '.join(map(str, guarded_warehouses)))