import itertools


def manhattan_distance(point1, point2):
    x1, y1 = point1
    x2, y2 = point2
    return abs(x1 - x2) + abs(y1 - y2)


def find_shortest_manhattan_route(points):
    n = len(points)
    shortest_route_length = float('inf')

    for permutation in itertools.permutations(points):
        current_distance = 0


        for i in range(n - 1):
            current_distance += manhattan_distance(permutation[i], permutation[i + 1])


        shortest_route_length = min(shortest_route_length, current_distance)

    return shortest_route_length

n = int(input().strip())
points = [tuple(map(int, input().strip().split())) for _ in range(n)]

shortest_route_length = find_shortest_manhattan_route(points)

print(f"{shortest_route_length:.12f}")