import itertools
import math


def calculate_distance(p1, p2):
    return math.sqrt((p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2)

def main():
    n = int(input())
    points = []

    for i in range(n):
        x, y = map(int, input().strip().split())
        points.append((x, y))

    distances = [[0] * n for _ in range(n)]
    for i in range(n):
        for j in range(n):
            if i != j:
                distances[i][j] = calculate_distance(points[i], points[j])

    min_length = float('inf')

    for perm in itertools.permutations(range(n)):
        current_length = 0
        for i in range(n - 1):
            current_length += distances[perm[i]][perm[i + 1]]

        min_length = min(min_length, current_length)

    print(f"{min_length:.12f}")


if __name__ == "__main__":
    main()